SystemOrganization addCategory: #'SystemEditor-Tests'!
SystemOrganization addCategory: #'SystemEditor-Editors'!

SharedPool subclass: #EditorSubjectPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

Behavior subclass: #MetaclassEditor
	instanceVariableNames: 'editor instVarNames methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!MetaclassEditor class methodsFor: 'instance creation' stamp: 'cwp 10/23/2005 14:38'!
new
	| instance |
	instance _ self basicNew.
	instance
		superclass: ClassEditor
		methodDictionary: MethodDictionary new
		format: ClassEditor format.
	^ instance! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 23:16'!
addInstVarName: aString 
	instVarNames ifNil: [instVarNames _ self subject instVarNames].
	instVarNames _ instVarNames copyWith: aString! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 18:21'!
classPool
	^ editor classPool! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/28/2005 08:10'!
compile: source classified: category withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := ModifiedMethod
			source: source
			classified: category
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods add: cm.! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 10/24/2005 07:33'!
edBuild
	| result |
	result _ self subject clone.
	result setInstVarNames: self instVarNames.
	^ result! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 07:40'!
format
	"Override the implemenation in Behavior. That will return the format of ClassEditor,
	but we want the format of the subject's meta class"

	| superFormat |
	superFormat := ClassFormat fromBits: self subject superclass format.
	^ (superFormat namedSubclass: self instVarNames size) bits! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/28/2005 08:11'!
includesSelector: aSelector
	^ (methods ifNil: [self subject] ifNotNil: [methods])
		includesSelector: aSelector! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/23/2005 23:17'!
instVarNames
	"Override the implemenation in Behavior. That will return the inst vars of 
	ClassEditor, but we want the inst vars of the subject's meta class."

	^ instVarNames ifNil: [self subject instVarNames]! !

!MetaclassEditor methodsFor: 'metaclass' stamp: 'cwp 10/23/2005 14:43'!
new
	^ editor _ self basicNew! !

!MetaclassEditor methodsFor: 'printing' stamp: 'cwp 10/23/2005 14:45'!
printOn: aStream
	aStream
		nextPutAll: 'a MetaclassEditor on: ';
		print: editor subject ! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/27/2005 08:31'!
removeInstVarName: aString 
	instVarNames ifNil: [instVarNames _ self subject instVarNames].
	instVarNames _ instVarNames copyWithout: aString! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/28/2005 08:20'!
removeSelector: aSymbol 
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods remove: aSymbol.! !

!MetaclassEditor methodsFor: 'accessing' stamp: 'cwp 10/23/2005 14:45'!
subject
	^ editor subject class! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/27/2005 08:35'!
superclass
	^ subjectSuperclass ifNil: [self subject superclass]! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/27/2005 08:41'!
superclass: aClass
	"We override the implementation in Behavior, because we
	don't want people messing with the editor's behavior. See also
	the comment in MetaclassEditorProtocolTest>>test04Superclass"! !

Object subclass: #ClassEditor
	instanceVariableNames: 'subject superclass type instVarNames classVarNames sharedPools methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ClassEditor class methodsFor: 'instance creation' stamp: 'cwp 10/23/2005 14:35'!
on: aClass
	| meta instance |
	meta _ MetaclassEditor new.
	instance _ meta new.
	instance setSubject: aClass.
	^ instance! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/24/2005 08:27'!
addClassVarName: aSymbol
	classVarNames ifNil: [classVarNames _ subject classVarNames].
	classVarNames _ classVarNames copyWith: aSymbol asSymbol! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 15:36'!
addInstVarName: aString 
	instVarNames ifNil: [instVarNames _ subject instVarNames].
	instVarNames _ instVarNames copyWith: aString! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 16:03'!
addSharedPool: aSharedPool 
	sharedPools ifNil: [sharedPools _ subject sharedPools].
	sharedPools _ sharedPools copyWith: aSharedPool! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/26/2005 23:14'!
allInstVarNames
	^ instVarNames
		ifNil: [self subject instVarNames]
		ifNotNil: [self subject superclass instVarNames, instVarNames]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 18:28'!
classPool
	| pool |
	pool _ self subject classPool copy.
	classVarNames ifNil: [^ pool].
	pool keys do: [:ea | (classVarNames includes: ea) ifFalse: [pool removeKey: ea]].
	classVarNames do: [:ea | (pool includesKey: ea) ifFalse: [pool at: ea put: nil]].
	^ pool! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/23/2005 15:41'!
classVarNames
	^ classVarNames ifNil: [subject classVarNames]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 22:50'!
compile: source classified: category withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := ModifiedMethod
			source: source
			classified: category
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods add: cm.! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/24/2005 19:02'!
edBuild
	| meta result |
	self edRequiresBuild ifFalse: [^ subject].
	meta _ self class edBuild.
	result _ meta adoptInstance: subject from: subject class.
	result
		superclass: self superclass
		methodDictionary: MethodDictionary new
		format: self format;
		setInstVarNames: self instVarNames;
		classPoolFrom: self;
		instVarNamed: #sharedPools put: self sharedPools.

	^ result! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/29/2005 10:20'!
edClassFormat
	| superFormat |
	superFormat _ ClassFormat fromBits: self superclass format.
	^ self typeOfClass = #normal
		ifTrue: [superFormat namedSubclass: self instVarNames size]
		ifFalse: [superFormat indexedSubclass: self instVarNames size]! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/24/2005 18:52'!
edRequiresBuild
	^ superclass ~~ nil
		| instVarNames ~~ nil
		| classVarNames ~~ nil
		| sharedPools ~~ nil! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:19'!
format
	^ self edClassFormat bits! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/25/2005 22:35'!
includesSelector: aSelector
	^ (methods ifNil: [self subject] ifNotNil: [methods])
		includesSelector: aSelector! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/23/2005 15:37'!
instVarNames
	^ instVarNames ifNil: [subject instVarNames]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:23'!
isBits
	^ #(bytes words) includes: self typeOfClass! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:22'!
isBytes
	^ self typeOfClass = #bytes! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:24'!
isPointers
	^ #(normal weak variable) includes: self typeOfClass! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:26'!
isVariable
	^ (self typeOfClass = #normal) not! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:34'!
isWeak
	^ self typeOfClass = #weak! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:33'!
isWords
	^ #(words weak variable) includes: self typeOfClass ! !

!ClassEditor methodsFor: 'compiling' stamp: 'cwp 10/27/2005 08:00'!
literalScannedAs: literal notifying: anEncoder 
	literal isVariableBinding ifTrue: [self halt].
	^ literal! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/26/2005 22:49'!
methodDictionary
	^ methods
		ifNil: [subject methodDictionary]
		ifNotNil: [methods buildFor: self]! !

!ClassEditor methodsFor: 'printing' stamp: 'cwp 10/23/2005 02:58'!
printOn: aStream
	aStream 
		nextPutAll: 'a ClassEditor on: ';
		nextPutAll: subject name! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 15:58'!
removeClassVarName: aString 
	classVarNames ifNil: [classVarNames _ subject classVarNames].
	classVarNames _ classVarNames copyWithout: aString! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 15:39'!
removeInstVarName: aString 
	instVarNames ifNil: [instVarNames _ subject instVarNames].
	instVarNames _ instVarNames copyWithout: aString! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 23:03'!
removeSelector: aSymbol 
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods remove: aSymbol.! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 16:06'!
removeSharedPool: aSharedPool 
	sharedPools ifNil: [sharedPools _ subject sharedPools].
	sharedPools _ sharedPools copyWithout: aSharedPool! !

!ClassEditor methodsFor: 'initialize-release' stamp: 'cwp 10/23/2005 15:36'!
setSubject: aClass
	subject _ aClass.
	! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 18:57'!
sharedPools
	^ sharedPools ifNil: [subject sharedPools]! !

!ClassEditor methodsFor: 'accessing' stamp: 'cwp 10/23/2005 01:54'!
subject
	^ subject! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 07:54'!
superclass
	^ superclass ifNil: [self subject superclass]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 07:54'!
superclass: aClass
	superclass _ aClass! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/28/2005 22:14'!
typeOfClass
	^ type ifNil: [type _ subject typeOfClass]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/29/2005 10:28'!
typeOfClass: aSymbol
	type _ aSymbol! !

Object subclass: #ClassFormat
	instanceVariableNames: 'instSize instSpec cClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ClassFormat commentStamp: 'cwp 9/25/2004 16:07' prior: 0!
I am an expert on the way the Squeak VM encodes class formats. My instance variable, 'bits', is identical in format to the 'format' instance variable of Behavior. I have methods for interpreting those bits. The class format integer is 18 bits in length. The instSize field is split into two parts for backwards compatibility.

<2 bits=instSize//64> <5 bits=cClass> <4 bits=instSpec> <6 bits=instSize\\64> <1 bit=0>

- instSize: the number of named instance variables
- cClass: the index into the compact class table
- instSpec: values indicating how instances are organized
	0 - no state
	1 - named instance variables only
	2 - variable number of object pointers
	3 - named instance variables, variable number of object pointers
	4 - variable number of weak object pointers
	6 - variable number of words
	8 - variable number of bytes!

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:14'!
bytes
	^ self size: 0 spec: self bytesSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
bytesSpec
	^ 8! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:41'!
fromBits: bits
	^ self
		size: (((bits bitShift: -10) bitAnd: 192) + ((bits bitShift: -1) bitAnd: 63) - 1)
		spec: ((bits bitShift: -7) bitAnd: 15)
		index: ((bits bitShift: -11) bitAnd: 31)! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:12'!
indexed
	^ self indexed: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:57'!
indexedSpec
	^ 2! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 18:08'!
indexedSpec: size
	^ size = 0 ifTrue: [self indexedSpec] ifFalse: [self namedAndIndexedSpec]! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:03'!
indexed: size
	^ self 
		size: size
		spec: (self indexedSpec: size)
		index: 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:59'!
named
	^ self named: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:57'!
namedAndIndexedSpec
	^ 3! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:55'!
namedSpec
	^ 1! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:06'!
named: size
	^ self
		size: size
		spec: self namedSpec
		index: 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:16'!
noState
	^ self size: 0 spec: self noStateSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:55'!
noStateSpec
	^ 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:41'!
size: instSize spec: instSpec index: cClassIndex
	^ self new setSize: instSize spec: instSpec index: cClassIndex! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:18'!
weak
	^ self size: 0 spec: self weakSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
weakSpec
	^ 4! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:17'!
words
	^ self size: 0 spec: self wordsSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
wordsSpec
	^ 6! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
bits
	"Based on ClassBuilder>>format:variable:words:pointers:weak - ar 7/11/1999 06:39 "

	| bits |
	bits _ (instSize+1) // 64. 	
	bits _ (bits bitShift: 5) + cClassIndex.
	bits _ (bits bitShift: 4) + instSpec.
	bits _ (bits bitShift: 6) + ((instSize+1)\\64).  "+1 since prim instSize field includes header"
	bits _ (bits bitShift: 1). "This shift plus integer bit lets wordSize work like byteSize"
	^ bits! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:36'!
cClassIndex
	^ cClassIndex! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:15'!
indexedSubclass: nInstVars
	| newSize |
	self isPointers ifFalse: [self error: 'Can''t make a pointer subclass.'].
	newSize _ self instSize + nInstVars.
	newSize > 254 ifTrue: [self error: 'Too many instance variables'].
	
	^ self class indexed: newSize! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
instSize
	^ instSize! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
instSpec
	^ instSpec! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:47'!
isBits
	"Answer whether the receiver contains just bits (not pointers)."

	^ self instSpec >= 6! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isBytes
	"Answer whether the receiver has 8-bit instance variables."

	^ self instSpec >= 8! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isFixed
	"Answer whether the receiver does not have a variable (indexable) part."

	^self isVariable not! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isPointers
	"Answer whether the receiver contains just pointers (not bits)."

	^self isBits not! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isVariable
	"Answer whether the receiver has indexable variables."

	^ self instSpec >= 2! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isWeak
	"Answer whether the receiver has contains weak references."
	^ self instSpec = 4! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:49'!
isWords
	"Answer whether the receiver has 32-bit instance variables."

	^ self isBytes not! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:09'!
namedSubclass: nInstVars 
	| newSize |
	newSize := self instSize + nInstVars.
	newSize > 254 ifTrue: [self error: 'Too many instance variables'].
	^self class named: newSize! !

!ClassFormat methodsFor: 'initializing' stamp: 'cwp 9/26/2004 17:39'!
setSize: size spec: spec index: index
	instSize _ size.
	instSpec _ spec.
	cClassIndex _ index.! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:28'!
withInstSize: aSmallInteger
	self isPointers ifFalse: [self error: 'Only pointer formats can have named variables'].
	^ self class size: aSmallInteger spec: self instSpec index: self cClassIndex! !

Object subclass: #EditorSubject
	instanceVariableNames: 'alpha beta'
	classVariableNames: 'Aleph Beth'
	poolDictionaries: 'EditorSubjectPool'
	category: 'SystemEditor-Tests'!

EditorSubject class
	instanceVariableNames: 'omega'!

!EditorSubject class methodsFor: 'accessing class vars' stamp: 'cwp 10/24/2005 18:38'!
aleph
	^ Aleph ! !

!EditorSubject class methodsFor: 'accessing class vars' stamp: 'cwp 10/24/2005 18:38'!
aleph: anObject
	Aleph _ anObject! !

!EditorSubject class methodsFor: 'methods for editing' stamp: 'cwp 10/28/2005 08:18'!
ayin
	^ 22! !

!EditorSubject methodsFor: 'phoenician' stamp: 'cwp 10/26/2005 08:41'!
het
	^ 'first letter of the phoenician alphabet'! !

Object subclass: #MethodDictionaryEditor
	instanceVariableNames: 'subject additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!MethodDictionaryEditor class methodsFor: 'instance creation' stamp: 'cwp 10/25/2005 22:48'!
on: aMethodDictionary 
	^ self new setSubject: aMethodDictionary! !

!MethodDictionaryEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 22:51'!
add: aModifiedMethod 
	additions at: aModifiedMethod selector put: aModifiedMethod! !

!MethodDictionaryEditor methodsFor: 'building' stamp: 'cwp 10/26/2005 22:49'!
buildFor: classEditor
	| result |
	result _ MethodDictionary new.
	subject keysAndValuesDo:
		[:selector :cm |
		(self selectorIsModified: selector)
			ifFalse: [result at: selector put: cm]].
	additions keysAndValuesDo: 
		[:selector :cm | 
		result at: selector put: (cm compileFor: classEditor)].
	^ result
! !

!MethodDictionaryEditor methodsFor: 'testing' stamp: 'cwp 10/28/2005 08:15'!
includesSelector: aSymbol 
	(additions includesKey: aSymbol) ifTrue: [^ true].
	(removals includes: aSymbol) ifTrue: [^false].
	(subject includesKey: aSymbol) ifTrue: [^ true].
	^ false! !

!MethodDictionaryEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 23:08'!
remove: aSymbol 
	additions removeKey: aSymbol ifAbsent: [].
	removals add: aSymbol! !

!MethodDictionaryEditor methodsFor: 'testing' stamp: 'cwp 10/26/2005 08:44'!
selectorIsModified: aSelector
	^ (additions includesKey: aSelector) or: [removals includes: aSelector]! !

!MethodDictionaryEditor methodsFor: 'initialization' stamp: 'cwp 10/25/2005 23:04'!
setSubject: aMethodDictionary
	subject _ aMethodDictionary.
	additions _ IdentityDictionary new.
	removals _ IdentitySet new.! !

Object subclass: #ModifiedMethod
	instanceVariableNames: 'source category stamp requestor log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ModifiedMethod class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 21:36'!
source: source classified: catString stamp: stamp notifying: requestor logging: aBoolean
	^ self new
		setSource: source
		classified: catString
		stamp: stamp
		notifying: requestor
		log: aBoolean! !

!ModifiedMethod methodsFor: 'building' stamp: 'cwp 10/27/2005 08:04'!
compileFor: aClassEditor
	| node |
	node _ aClassEditor subject compilerClass new
				compile: source
				in: aClassEditor
				notifying: requestor
				ifFail: nil.
	node encoder requestor: requestor.
	^ (CompiledMethodWithNode generateMethodFromNode: node trailer: #(0 0 0 0))
		method! !

!ModifiedMethod methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 22:50'!
selector
	^ Parser new parseSelector: source! !

!ModifiedMethod methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 22:47'!
setSource: sourceString classified: catString stamp: timestamp notifying: anObject log: aBoolean
	source _ sourceString.
	category _ catString.
	stamp _ timestamp.
	requestor _ anObject.
	log _ aBoolean ! !

Object subclass: #SystemEditor
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!SystemEditor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/28/2005 08:51'!
new
	^ self on: Smalltalk! !

!SystemEditor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/28/2005 08:51'!
on: anEnvironment
	^ self basicNew setSubject: anEnvironment! !

!SystemEditor methodsFor: 'reflecting' stamp: 'cwp 10/28/2005 20:52'!
at: aSymbol
	^ ClassEditor on: (self subject at: aSymbol)! !

!SystemEditor methodsFor: 'initialize-release' stamp: 'cwp 10/28/2005 08:49'!
setSubject: anEnvironment
	subject _ anEnvironment! !

!SystemEditor methodsFor: 'accessing' stamp: 'cwp 10/28/2005 08:49'!
subject
	^ subject! !

TestCase subclass: #ClassEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

ClassEditorTest subclass: #ClassEditorBuildTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 22:07'!
test01NoChange
	"Since there was no change, we don't have to rebuild the class at all."

	self assert: editor edBuild == editor subject.! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 22:08'!
test02AddInstVar
	
	| result |
	editor addInstVarName: 'gamma'.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: result name == editor subject name.
	self assert: result instVarNames = editor instVarNames.
	self assert: result format = editor format.! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:07'!
test03Superclass
	
	| result |
	editor superclass: self class.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: result superclass == self class.! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:14'!
test04AddClassVar
	
	| result |
	editor addClassVarName: 'Gimel'.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: result classVarNames = editor classVarNames! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 18:37'!
test05RemoveClassVar
	
	| result |
	editor removeClassVarName: 'Beth'.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: result classVarNames = editor classVarNames! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 18:40'!
test06PreserveClassVar
	
	| result object |
	object _ Object new.
	editor removeClassVarName: 'Beth'.
	editor subject aleph: object.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: result aleph == object! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 18:56'!
test07AddSharedPool
	
	| result pool |
	pool _ Dictionary new.
	editor addSharedPool: pool.
	result _ editor edBuild.
	self deny: result = editor subject.
	self assert: (result sharedPools includes: pool).
	self deny: (editor subject sharedPools includes: pool).! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 19:00'!
test08RemoveSharedPool
	
	| result |
	editor removeSharedPool: EditorSubjectPool.
	result _ editor edBuild.
	self deny: result = editor subject.
	self deny: (result sharedPools includes: EditorSubjectPool).
	self assert: (editor subject sharedPools includes: EditorSubjectPool).! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 08:45'!
test09ExistingMethods
	
	| dict |
	dict _ editor methodDictionary.
	self assert: (dict at: #het) == (editor subject compiledMethodAt: #het)! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 22:25'!
test10MethodRemoved
	
	| dict |
	editor removeSelector: #het.
	dict _ editor methodDictionary.
	self assert: dict isEmpty! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/27/2005 08:27'!
test11MethodAdded
	
	| dict |
	editor 
		compile: 'zayin ^ 2'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	dict _ editor methodDictionary.
	self assert: (dict at: #zayin) isCompiledMethod.
! !

ClassEditorTest subclass: #ClassEditorOntologyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:06'!
test01Creation
	"This invariant allows editors and their subject classes to use
	exactly the same reflection protocol, so that the only modification
	required to allow tools to modify the system atomically is to send
	#commit when all modifications are complete."

	self assert: editor subject == EditorSubject.
	self assert: editor class subject == EditorSubject class! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:06'!
test02Printing
	"This makes debugging easier."
	
	self assert: editor printString = 'a ClassEditor on: EditorSubject'.
	self assert: editor class printString = 'a MetaclassEditor on: EditorSubject'.! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:47'!
test03ClassReferences

	"The instance is a strange beast. Its class is created on the fly, and is
	both an instance of MetaclassEditor and a subclass of ClassEditor. 
	See #testCreation." 
	self assert: editor class class == MetaclassEditor.
	self assert: (editor class instVarNamed: 'superclass') == ClassEditor.


	"editor is an instance of a light-weight class, so we don't register it
	with its superclass. In fact, the only thing that keeps it from being
	garbage collected is the class pointer from editor."
	self deny: (ClassEditor subclasses includes: editor class).

! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:07'!
test04IsKindOfClass
	"A class and its editor are polymorphic, but this kind of
	explicit test can tell the difference."

	self deny: (editor class isKindOf: Class)! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:24'!
test05ClassPool
	"To have DoIts be executed in the right context by a debugger or inspector,
	the generated class needs to be adoptable by FakeClassPool."

	self 
		shouldnt: [FakeClassPool adopt: editor class]
		raise: Error.! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:36'!
test06Format
	"Despite having an instance variable call 'format' 
	MetaclassEditors should answer the format of the 
	subject's metaclass, not the format of ClassEditor class."

	self assert: editor class format = EditorSubject class format! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:43'!
test07Superclass
	"Despite having an instance variable call 'superclass' 
	MetaclassEditors should answer the superclass of the 
	subject's class, not ClassEditor."

	self assert: editor class superclass = EditorSubject class superclass! !

ClassEditorTest subclass: #ClassEditorProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:40'!
test01InstVarNames
	self assert: editor instVarNames = editor subject instVarNames! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:36'!
test02AddInstVarName
	editor addInstVarName: 'gamma'.
	self assert: editor instVarNames = (editor subject instVarNames copyWith: 'gamma')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:58'!
test03RemoveClassVarName
	editor removeClassVarName: 'Beth'.
	self assert: editor classVarNames = (editor subject classVarNames copyWithout: 'Beth')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:40'!
test04ClassVarNames
	self assert: editor classVarNames = editor subject classVarNames! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:23'!
test05AddClassVarName
	editor addClassVarName: #Gimel.
	self assert: editor classVarNames = (editor subject classVarNames copyWith: #Gimel)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:59'!
test06RemoveClassVarName
	editor removeClassVarName: 'Beth'.
	self assert: editor classVarNames = (editor subject classVarNames copyWithout: 'Beth')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 16:00'!
test07SharedPools
	self assert: editor sharedPools = editor subject sharedPools! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 16:47'!
test08AddSharedPool
	| pool |
	pool _ Dictionary new.
	editor addSharedPool: pool.
	self assert: editor sharedPools = (editor subject sharedPools copyWith: pool)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:51'!
test09RemoveSharedPool
	editor removeSharedPool: EditorSubjectPool.
	self assert: editor sharedPools = (editor subject sharedPools copyWithout: EditorSubjectPool)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:53'!
test10Superclass
	editor superclass: self class.
	self assert: editor superclass == self class.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:27'!
test11ClassVarNamesInterned
	editor addClassVarName: 'Gimel'.
	self assert: (editor classVarNames anySatisfy: [:ea | ea == #Gimel])! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 08:40'!
test12AddSelector
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	self assert: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:13'!
test13RemoveSelector
	editor removeSelector: #het.
	self deny: (editor includesSelector: #het)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 08:40'!
test14AddAndRemoveSelector
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	editor removeSelector: #zayin.
	self deny: (editor includesSelector: #zayin).
	! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:16'!
test15RemoveNewSelector
	editor removeSelector: #zayin.
	self deny: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 22:06'!
test16TypeOfClass
	editor typeOfClass = #normal! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:20'!
test17Format
	| superFormat editorFormat |
	superFormat _ ClassFormat fromBits: EditorSubject superclass format.
	editorFormat _ superFormat namedSubclass: editor instVarNames size.
	self assert: editor format = editorFormat bits! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:29'!
test18NewFormat
	| superFormat editorFormat |
	editor typeOfClass: #variable.
	superFormat _ ClassFormat fromBits: EditorSubject superclass format.
	editorFormat _ superFormat indexedSubclass: editor instVarNames size.
	self assert: editor format = editorFormat bits! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:27'!
test19BeBytes
	editor typeOfClass: #bytes.
	self assert: editor typeOfClass == #bytes.
	self assert: editor isBytes.
	self assert: editor isBits.
	self assert: editor isVariable.
	self deny: editor isPointers.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:28'!
test20BeWords
	editor typeOfClass: #words.
	self assert: editor typeOfClass == #words.
	self assert: editor isWords.
	self assert: editor isBits.
	self assert: editor isVariable.
	self deny: editor isPointers.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:33'!
test21BeWeak
	editor typeOfClass: #weak.
	self assert: editor typeOfClass == #weak.
	self assert: editor isWords.
	self assert: editor isVariable.
	self assert: editor isPointers.
	self deny: editor isBits.
! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:34'!
test22BeVariable
	editor typeOfClass: #variable.
	self assert: editor typeOfClass == #variable.
	self assert: editor isWords.
	self assert: editor isVariable.
	self assert: editor isPointers.
	self deny: editor isWeak.
	self deny: editor isBits.
! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:35'!
test23BeNormal
	editor typeOfClass: #normal.
	self assert: editor typeOfClass == #normal.
	self assert: editor isPointers.
	self deny: editor isWords.
	self deny: editor isVariable.
	self deny: editor isWeak.
	self deny: editor isBits.
! !

!ClassEditorTest class methodsFor: 'testing' stamp: 'cwp 10/23/2005 15:31'!
isAbtract
	^ self name == #ClassEditorTest! !

!ClassEditorTest methodsFor: 'running' stamp: 'cwp 10/23/2005 15:29'!
setUp
	editor := ClassEditor on: EditorSubject! !

TestCase subclass: #ClassFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testBitsWithInstSize
	| format |
	format _ ClassFormat bytes.
	self should: [format withInstSize: 2] raise: Error! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testBytes
	| format |
	format := ClassFormat bytes.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isBytes.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isWords.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testIndexed
	| format |
	format := ClassFormat indexed.
	self assert: format instSize = 0.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testIndexedSubclass
	| superFormat subFormat |
	superFormat := ClassFormat named: 3.
	subFormat := superFormat indexedSubclass: 2.
	self assert: superFormat instSize = 3.
	self assert: subFormat instSize = 5.
	self assert: subFormat isVariable.
	self assert: subFormat isPointers.
	self assert: subFormat isWords.
	self deny: subFormat isFixed.
	self deny: subFormat isBits.
	self deny: subFormat isBytes.
	self deny: subFormat isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testIndexedWithInstSize
	| old new |
	old _ ClassFormat indexed: 3.
	new _ old withInstSize: 5.
	self assert: new instSize = 5.
	self assert: new instSpec = old instSpec.
	self assert: new cClassIndex = old cClassIndex! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testNamed
	| format |
	format := ClassFormat named: 3.
	self assert: format instSize = 3.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedAndIndexed
	| format |
	format := ClassFormat indexed: 3.
	self assert: format instSize = 3.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedSubclass
	| superFormat subFormat |
	superFormat := ClassFormat named: 3.
	subFormat := superFormat namedSubclass: 2.
	self assert: superFormat instSize = 3.
	self assert: subFormat instSize = 5.
	self assert: subFormat isFixed.
	self assert: subFormat isPointers.
	self assert: subFormat isWords.
	self deny: subFormat isVariable.
	self deny: subFormat isBits.
	self deny: subFormat isBytes.
	self deny: subFormat isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedWithInstSize
	| old new |
	old _ ClassFormat named: 3.
	new _ old withInstSize: 5.
	self assert: new instSize = 5.
	self assert: new instSpec = old instSpec.
	self assert: new cClassIndex = old cClassIndex! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNoState
	| format |
	format := ClassFormat noState.
	self assert: format instSize = 0.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testWeak
	| format |
	format := ClassFormat weak.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isWeak.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testWords
	| format |
	format := ClassFormat words.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isWords.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isBytes.
	self deny: format isWeak
! !

TestCase subclass: #MetaclassEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

MetaclassEditorTest subclass: #MetaclassEditorBuildTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!MetaclassEditorBuildTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2005 08:02'!
test01InstVars
	| result |
	result _ editor edBuild.
	self assert: result instVarNames = editor instVarNames! !

MetaclassEditorTest subclass: #MetaclassEditorProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 22:50'!
test01InstVarNames
	self assert: editor instVarNames = editor subject instVarNames! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 23:14'!
test02AddInstVarName
	editor addInstVarName: 'psi'.
	self assert: editor instVarNames = (editor subject instVarNames copyWith: 'psi')! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/27/2005 08:31'!
test03RemoveInstVarName
	editor removeInstVarName: 'omega'.
	self assert: editor instVarNames = (editor subject instVarNames copyWithout: 'omega')! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/27/2005 08:38'!
test04Superclass
	"Although it would be technically correct to implement #superclass:
	in MetaclassEditor so that the metaclass's superclass can be set, that's
	a bizarre usecase. Not supported for now."	

	editor superclass: self class.
	self assert: editor superclass == editor subject superclass.! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:09'!
test5AddSelector
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	self assert: (editor includesSelector: #zayin)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:19'!
test6RemoveNewSelector
	editor removeSelector: #pe.
	self deny: (editor includesSelector: #pe)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:19'!
test7RemoveSelector
	editor removeSelector: #ayin.
	self deny: (editor includesSelector: #ayin)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:23'!
test8AddAndRemoveSelector
	editor 
		compile: 'pe ^ 1'
		classified: 'phoenician'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	editor removeSelector: #pe.
	self deny: (editor includesSelector: #pe).
	! !

!MetaclassEditorTest methodsFor: 'running' stamp: 'cwp 10/24/2005 07:57'!
setUp
	editor _ (ClassEditor on: EditorSubject) class! !

TestCase subclass: #SystemEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!SystemEditorTest methodsFor: 'running' stamp: 'cwp 10/28/2005 20:41'!
setUp
	editor _ SystemEditor new.
! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 10/28/2005 08:49'!
test01ExplicitCreation
	editor _ SystemEditor on: Smalltalk.
	self assert: editor subject == Smalltalk! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 10/28/2005 20:41'!
test02ImplicitCreation
	self assert: editor subject == Smalltalk! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 10/28/2005 20:44'!
test03At
	| classEditor |
	classEditor _ editor at: #EditorSubject.
	self assert: classEditor subject = EditorSubject! !
